require "tempfile"
require "ace/util"

module Ace
    class YumUpdater
        include Ace::Util
        
        YUMHELPER = File::join(File::dirname(__FILE__), "yumhelper.py")
        
        def updates_pending?
            output, status = clean_exec("/usr/bin/yum check-update ")
            status == 100
        end
        
        def pending_updates
            updates = Array.new()
            output, status = clean_exec("python #{YUMHELPER} ")
            output.each_line do |l|
                l.chomp!
                next if l.empty?
                if (l[0,4] == "_pkg")
                    updates << l[5..-1].split()[0]
                end
            end
            updates.sort()
        end
        
        def update
            output, status = clean_exec("/usr/bin/yum -y update2 ")
            status == 0
        end
    end
end
