#-- 
#  Copyright (C) 2008 Red Hat Inc.
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#  
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#  
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
#
# Author: Bryan Kearney <bkearney@redhat.com>
#--
require "ace/util"

# Executes a postgres sql file, and drops a file 
# to record that it was executed.
Puppet::Type.newtype(:post_url) do
        include Puppet::Util
        
		autorequire :file do
			["/var/ace/single_execs"]
		end
		        
        newparam (:name) do 
        	isnamevar
        end    

        newparam (:url_parameters) do 
        	
        end
        
        newparam(:url) do
        end       
        
        
        newproperty(:returns) do |property|
            include Puppet::Util
        	include Ace::Util            
            
            munge do |value|
                value.to_s
            end
            
            defaultto 0

            # Make output a bit prettier
            def change_to_s(currentvalue, newvalue)
                return "executed successfully"
            end
            
            def retrieve
                # Returns garbage if we need to run,or the current
                # value if we do not.
                if !FileTest.exists?("/var/ace/single_execs/#{self.resource[:name]}")        
                    return :need_to_run_this
                else         
                    return self.should
                end
            end            

            # Actually execute the command.
            def sync          
            	parameter_hash = deserialize_hash(self.resource[:url_parameters])
            	success, return_code = post_url(self.resource[:url], parameter_hash)
            	if success
					execute(["/bin/date >> /var/ace/single_execs/#{self.resource[:name]}"])
				else
					self.fail("Url post returned a #{return_code} response")
				end
                return :executed
            end
		end
end
