#import "augeas"

file {"/etc/sysconfig/firstboot":
    content => "RUN_FIRSTBOOT=NO\n"
}

augeas{"test1" :
    context => "/files/etc/sysconfig/firstboot",
    changes => "set 'RUN_FIRSTBOOT' 'YES'",
    require => File["/etc/sysconfig/firstboot"],
}


$changes = [
    "set RUN_FIRSTBOOT Perhaps",
    "set JarJar Binks"
]

augeas{"test2" :
    context => "/files/etc/sysconfig/firstboot",
    require => Augeas[test1],
    changes => $changes
}

augeas{"test3" :
    require => Augeas[test2],
    changes => "set /files/etc/sysconfig/firstboot/Tiddly winks"
}

augeas{"test4" :
    require => Augeas[test3],
    changes => "rm /files/etc/sysconfig/firstboot/Absent"
}

augeas{"test_typecheck":
    require => Augeas[test4],
    changes => $changes,
    type_check => true
}

augeas{"test_onlyif_should_execute":
    require => Augeas[test_typecheck],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_onlyif_should_execute",
    onlyif => "get JarJar == Binks",
}

augeas{"test_onlyif_should_not_execute":
    require => Augeas[test_onlyif_should_execute],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_onlyif_should_not_execute",
    onlyif => "get JarJar == Binks",
}

augeas{"test_match_1":
    require => Augeas[test_onlyif_should_execute],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_match_1",
    onlyif => "match JarJar size > 0",
}

augeas{"test_match_should_not_execute_1":
    require => Augeas[test_match_1],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_match_should_not_execute_1",
    onlyif => "match JarJar size > 10",
}

augeas{"test_match_2":
    require => Augeas[test_match_should_not_execute_1],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_match_should_not_run_1",
    onlyif => "match * include /files/etc/sysconfig/firstboot/Tiddly",
}

augeas{"test_match_should_not_execute_2":
    require => Augeas[test_match_2],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_match_should_not_execute_2",
    onlyif => "match * include /files/etc/sysconfig/firstboot/TiddlyWinks",
}

augeas{"test_match_3":
    require => Augeas[test_match_should_not_execute_2],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_match_3",
    onlyif => "match JarJar == ['/files/etc/sysconfig/firstboot/JarJar']",
}

augeas{"test_match_should_not_execute_3":
    require => Augeas[test_match_3],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_match_should_not_execute_3",
    onlyif => "match JarJar == ['/files/etc/sysconfig/firstboot/JarJar', 'bogus/string']",
}

augeas{"test_match_should_not_execute_4":
    require => Augeas[test_match_should_not_execute_3],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_match_should_not_execute_4",
    onlyif => "get JarJar != test_match_3 ",
}

augeas{"test_not_equals_1":
    require => Augeas[test_match_should_not_execute_4],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_not_equals_1",
    onlyif => "get JarJar != Binks ",
}

augeas{"test_regex_1":
    require => Augeas[test_not_equals_1],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_regex_1",
    onlyif => "get JarJar =~ test_* ",
}

augeas{"test_regex_2_should_not_run":
    require => Augeas[test_regex_1],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set JarJar test_regex_1",
    onlyif => "get JarJar =~ Binks* ",
}

augeas{"test_missing_node_should_run":
    require => Augeas[test_regex_2_should_not_run],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set Boss Nass",
    onlyif => "get Boss != Nass ",
}

augeas{"test_missing_node2_should_not_run":
    require => Augeas[test_missing_node_should_run],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set Jango Fett",
    onlyif => "get Jango == Fett ",
}

augeas{"test_missing_node3_should_run":
    require => Augeas[test_missing_node2_should_not_run],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set Boba Fett",
    onlyif => "match Anakin size == 0",
}

augeas{"test_missing_node4_should_not_run":
    require => Augeas[test_missing_node3_should_run],
    context => "/files/etc/sysconfig/firstboot",    
    changes => "set Anakin Skywalker",
    onlyif => "match Boba size == 0",
}

