#!/bin/bash

firewallDir="/usr/share/firewall"

# firewallDir contains a directory for each table (filter, nat, mangle)
# - each table dir contains a dir for each chain in that table
# - each chain dir has link files that are iptables snippets
# - each table dir can contain a CHAIN.head file, which goes in front of the chain
# - each table dir can contain a CHAIN.tail file, which goes in back of the chain
# and should set default policy
# 
# Example firewallDir layout
# filter
#   INPUT
#     ftp
#     http
#     smb
#   INPUT.head
#   INPUT.tail
#   OUTPUT
#   OUTPUT.head
#   FORWARD
# nat
#   PREROUTING
#
# Any chains not in this tree will be removed from the running config
