#!/bin/bash

# deps:
#    bash
#    rpm
#    sed
#    cut
#    uniq
#    sort
# Taken from http://www.singularity.be/2008/07/making-dot-graphviz-graph-of-rpm.html

installedrpms=$(rpm -qa --queryformat "%{NAME}\n")


function printdeps() {
    local package deps dep providedby out

    package=$1
    deps=$(rpm -qR $package | cut -d " " -f 1)
    me=$(rpm -q --queryformat "%{NAME}(%{SIZE})\n" $package)
    out="\"$me\"\n"    

    for dep in $deps;
    do
        providedby=$(rpm -q --queryformat "%{NAME}(%{SIZE})\n" --whatprovides "$dep")
        if [ $? -eq 0 ];
        then
            # packages should not depend on themselves
            if [ "$me" != "$providedby" ];
            then
                out="$out\"$me\" -> \"$providedby\";\n"
            fi
        fi
    done

    echo -e $out | sort | uniq
}

alloutput=""

for i in $installedrpms;
do
    output=$(printdeps $i)
    #echo "$output"
    alloutput="$alloutput$output"
done


echo "digraph deptree {"
echo -e "$alloutput" | sort | uniq
echo "}"
